#!/usr/bin/env bash

instance=$1

if [[ ! -f ${instance}.tra || ! -f ${instance}.csl ]]; then
    echo "Could not find ${instance}.tra or ${instance}.csl"
    echo "Usage: property_check.sh <instance>"
fi

f=$(mktemp)
p=$(mktemp)
cp ${instance}.csl ${f}

# Release -> width
echo "A [ \"signal_clicked\" => (F \"signal_mEvent\") ]" >> ${f}

/home/bisneu/project/ictac/prism-4.7-linux64/bin/prism -dtmc -importtrans ${instance}.tra ${f} > ${p}

if [[ $? == 1 ]]; then
    echo "Error running PRISM"
fi

echo "Properties File: ${f}"
echo "PRISM Output: ${p}"

awk '
  BEGIN{ i = 0; }
  /Model checking:/ {
    prop[i] = "";
    for (j = 3; j <= NF; j++) {
      prop[i] = prop[i] $j
    }
  }
  /Result:/ { res[i++] = $2; i++ }
  END {
   for (i in res) {
     r = res[i]
     if (prop[i] != "" && r != "true") {
        print prop[i], r
     }
  }
}
' ${p}
